Index: code/branches/pickupsFS14/src/modules/jump/CMakeLists.txt
===================================================================
--- code/branches/pickupsFS14/src/modules/jump/CMakeLists.txt	(revision 10041)
+++ code/branches/pickupsFS14/src/modules/jump/CMakeLists.txt	(revision 10050)
@@ -6,5 +6,11 @@
   JumpPlatformHMove.cc
   JumpPlatformVMove.cc
+  JumpPlatformDisappear.cc
+  JumpPlatformTimer.cc
+  JumpPlatformFake.cc
+  JumpProjectile.cc
+  JumpEnemy.cc
   JumpFigure.cc
+  JumpItem.cc
   JumpCenterpoint.cc
   JumpScore.cc
Index: code/branches/pickupsFS14/src/modules/jump/Jump.cc
===================================================================
--- code/branches/pickupsFS14/src/modules/jump/Jump.cc	(revision 10041)
+++ code/branches/pickupsFS14/src/modules/jump/Jump.cc	(revision 10050)
@@ -47,4 +47,9 @@
 #include "JumpPlatformHMove.h"
 #include "JumpPlatformVMove.h"
+#include "JumpPlatformDisappear.h"
+#include "JumpPlatformTimer.h"
+#include "JumpPlatformFake.h"
+#include "JumpProjectile.h"
+#include "JumpEnemy.h"
 #include "JumpFigure.h"
 
@@ -70,6 +75,5 @@
         this->figure_ = 0;
         this->camera = 0;
-
-        platformList.clear();
+        this->fakeAdded_ = false;
 
         this->setHUDTemplate("JumpHUD");
@@ -78,5 +82,4 @@
         this->starttimer_.setTimer(1.0, false, createExecutor(createFunctor(&Jump::startBall, this)));
         this->starttimer_.stopTimer();
-
 
         this->scoreLimit_ = 10;
@@ -111,7 +114,7 @@
 
                 // Falls noetig neue Platformen im neuen Bereich einfuegen
-                if (screenShiftSinceLastUpdate > sectionLength)
+                if (screenShiftSinceLastUpdate > center_->getSectionLength())
                 {
-                	screenShiftSinceLastUpdate -= sectionLength;
+                	screenShiftSinceLastUpdate -= center_->getSectionLength();
                     addSection();
                 }
@@ -124,4 +127,11 @@
     		}
 
+    		// Schiessen
+    		if (figure_->fireSignal)
+    		{
+    			figure_->fireSignal = false;
+    			addProjectile(figurePosition.x, figurePosition.z, 0.0, 150.0);
+    		}
+
 
     		if (this->camera != NULL)
@@ -133,5 +143,5 @@
 			{
 				orxout() << "No camera found." << endl;
-				//this->camera = this->figure_->getCamera();
+				//camera = figure_->getCamera();
 			}
     	}
@@ -142,19 +152,103 @@
 
 		// Platformen, die zu weit unten sind entfernen
+		ObjectList<JumpPlatform>::iterator beginPlatform = ObjectList<JumpPlatform>::begin();
+		ObjectList<JumpPlatform>::iterator endPlatform = ObjectList<JumpPlatform>::end();
+		ObjectList<JumpPlatform>::iterator itPlatform = beginPlatform;
 		Vector3 platformPosition;
-		for (std::list<JumpPlatform*>::iterator it = platformList.begin(); it != platformList.end(); it++)
-		{
-			// IDEE: Statt durch alle platformen in der Liste, wie im Tutorial durch alle objekte im Spiel iterieren --> eigene liste unnoetig
-			platformPosition = (**it).getPosition();
+
+		while (itPlatform != endPlatform)
+		{
+			platformPosition = itPlatform->getPosition();
 			if (platformPosition.z < totalScreenShift - center_->getFieldDimension().y)
 			{
+				ObjectList<JumpPlatform>::iterator temp = itPlatform;
+				++ itPlatform;
+				center_->detach(*temp);
+				temp->destroy();
+			}
+			else
+			{
+				++ itPlatform;
+			}
+		}
+
+		// DAS GEHT NICHT!!! it++ funktioniert nicht, falls eine Platform geloescht wurde -> Segmentation Error
+		/*
+		for (ObjectList<JumpPlatformDisappear>::iterator it = ObjectList<JumpPlatformDisappear>::begin(); orxout() << "E" << endl, it != ObjectList<JumpPlatformDisappear>::end(); orxout() << "F" << endl, ++it)
+		{
+			if (!it->isActive())
+			{
 				// Entferne Platform
-				orxout() << "position = " << (**it).getPosition().y << endl;
 				center_->detach(*it);
-				it = platformList.erase(it);
-			}
-		}
-    }
-
+				it->destroy();
+			}
+		}
+		*/
+
+		// Deaktivierte Platformen entfernen
+		ObjectList<JumpPlatformDisappear>::iterator beginDisappear = ObjectList<JumpPlatformDisappear>::begin();
+		ObjectList<JumpPlatformDisappear>::iterator endDisappear = ObjectList<JumpPlatformDisappear>::end();
+		ObjectList<JumpPlatformDisappear>::iterator itDisappear = beginDisappear;
+
+		while (itDisappear != endDisappear)
+		{
+			if (!itDisappear->isActive())
+			{
+				ObjectList<JumpPlatformDisappear>::iterator temp = itDisappear;
+				++ itDisappear;
+				center_->detach(*temp);
+				temp->destroy();
+			}
+			else
+			{
+				++ itDisappear;
+			}
+		}
+
+		// Abgelaufene Timer-Platformen entfernen
+		ObjectList<JumpPlatformTimer>::iterator beginTimer = ObjectList<JumpPlatformTimer>::begin();
+		ObjectList<JumpPlatformTimer>::iterator endTimer = ObjectList<JumpPlatformTimer>::end();
+		ObjectList<JumpPlatformTimer>::iterator itTimer = beginTimer;
+
+		while (itTimer != endTimer)
+		{
+			if (!itTimer->isActive())
+			{
+				ObjectList<JumpPlatformTimer>::iterator temp = itTimer;
+				++ itTimer;
+				center_->detach(*temp);
+				temp->destroy();
+			}
+			else
+			{
+				++ itTimer;
+			}
+		}
+
+		// Projektile, die zu weit oben sind entfernen
+		ObjectList<JumpProjectile>::iterator beginProjectile = ObjectList<JumpProjectile>::begin();
+		ObjectList<JumpProjectile>::iterator endProjectile = ObjectList<JumpProjectile>::end();
+		ObjectList<JumpProjectile>::iterator itProjectile = beginProjectile;
+		Vector3 projectilePosition;
+
+		while (itProjectile != endProjectile)
+		{
+			projectilePosition = itProjectile->getPosition();
+			if (projectilePosition.z > totalScreenShift + 5*center_->getFieldDimension().y)
+			{
+				ObjectList<JumpProjectile>::iterator temp = itProjectile;
+				++ itProjectile;
+				center_->detach(*temp);
+				temp->destroy();
+			}
+			else
+			{
+				++ itProjectile;
+			}
+		}
+
+
+
+    }
 
     void Jump::setConfigValues()
@@ -169,15 +263,8 @@
     void Jump::cleanup()
     {
-        /*if (this->ball_ != NULL) // Destroy the ball, if present.
-        {
-            this->ball_->destroy();
-            this->ball_ = 0;
-        }*/
-
-        // Destroy both bats, if present.
 		if (this->figure_ != NULL)
 		{
-			this->figure_->destroy();
-			this->figure_ = 0;
+			//this->figure_->destroy();
+			//this->figure_ = 0;
 		}
 		this->camera = 0;
@@ -207,5 +294,5 @@
 			{
 				this->figure_ = new JumpFigure(this->center_->getContext());
-				this->figure_->addTemplate(this->center_->getBattemplate());
+				this->figure_->addTemplate(this->center_->getFigureTemplate());
 			}
 
@@ -213,10 +300,5 @@
             this->center_->attach(this->figure_);
             this->figure_->setPosition(-this->center_->getFieldDimension().x / 2, 0, 0);
-            this->figure_->yaw(Degree(-90));
-            this->figure_->setSpeed(this->center_->getBatSpeed());
             this->figure_->setFieldDimension(this->center_->getFieldDimension());
-            this->figure_->setLength(this->center_->getBatLength());
-
-
         }
         else // If no centerpoint was specified, an error is thrown and the level is exited.
@@ -248,5 +330,4 @@
         screenShiftSinceLastUpdate = 0.0;
         sectionNumber = 0;
-        sectionLength = 100.0;
 
         addStartSection();
@@ -261,5 +342,6 @@
     void Jump::end()
     {
-        this->cleanup();
+    	cleanup();
+    	GSLevel::startMainMenu();
 
         // Call end for the parent class.
@@ -393,13 +475,94 @@
     }
 
-    void Jump::addPlatform(JumpPlatform* newPlatform, float xPosition, float zPosition)
-    {
-    	if (newPlatform != NULL)
-		{
+    void Jump::addPlatform(JumpPlatform* newPlatform, std::string platformTemplate, float xPosition, float zPosition)
+    {
+    	if (newPlatform != NULL && center_ != NULL)
+		{
+    		newPlatform->addTemplate(platformTemplate);
     		newPlatform->setPosition(Vector3(xPosition, 0.0, zPosition));
     		newPlatform->setFieldDimension(center_->getFieldDimension());
     		newPlatform->setFigure(this->figure_);
     		center_->attach(newPlatform);
-    		platformList.push_front(newPlatform);
+		}
+    }
+
+    void Jump::addPlatformStatic(float xPosition, float zPosition)
+    {
+		if (fakeAdded_ == false && rand()%5 == 0)
+		{
+			addPlatformFake(xPosition, zPosition);
+		}
+		else
+		{
+	    	JumpPlatformStatic* newPlatform = new JumpPlatformStatic(center_->getContext());
+			addPlatform(newPlatform, center_->getPlatformStaticTemplate(), xPosition, zPosition);
+		}
+    }
+
+    void Jump::addPlatformHMove(float xPosition, float zPosition, float leftBoundary, float rightBoundary, float speed)
+    {
+    	JumpPlatformHMove* newPlatform = new JumpPlatformHMove(center_->getContext());
+		newPlatform->setProperties(leftBoundary, rightBoundary, speed);
+		addPlatform(newPlatform, center_->getPlatformHMoveTemplate(), xPosition, zPosition);
+    }
+
+    void Jump::addPlatformVMove(float xPosition, float zPosition, float lowerBoundary, float upperBoundary, float speed)
+    {
+    	JumpPlatformVMove* newPlatform = new JumpPlatformVMove(center_->getContext());
+		newPlatform->setProperties(lowerBoundary, upperBoundary, speed);
+		addPlatform(newPlatform, center_->getPlatformVMoveTemplate(), xPosition, zPosition);
+    }
+
+    void Jump::addPlatformDisappear(float xPosition, float zPosition)
+    {
+		JumpPlatformDisappear* newPlatform = new JumpPlatformDisappear(center_->getContext());
+		newPlatform->setProperties(true);
+		addPlatform(newPlatform, center_->getPlatformDisappearTemplate(), xPosition, zPosition);
+    }
+
+    void Jump::addPlatformTimer(float xPosition, float zPosition, float time, float variance)
+    {
+		float additionalTime = (float)(rand()%100)/(100*variance) - variance/2;
+
+    	JumpPlatformTimer* newPlatform = new JumpPlatformTimer(center_->getContext());
+		newPlatform->setProperties(time + additionalTime);
+		addPlatform(newPlatform, center_->getPlatformTimerTemplate(), xPosition, zPosition);
+    }
+
+    void Jump::addPlatformFake(float xPosition, float zPosition)
+    {
+    	fakeAdded_ = true;
+
+		JumpPlatformFake* newPlatform = new JumpPlatformFake(center_->getContext());
+		addPlatform(newPlatform, center_->getPlatformFakeTemplate(), xPosition, zPosition);
+		newPlatform->setAngularVelocity(Vector3(0, 0, 2.0));
+    }
+
+
+    void Jump::addProjectile(float xPosition, float zPosition, float xVelocity, float zVelocity)
+    {
+    	JumpProjectile* newProjectile = new JumpProjectile(center_->getContext());
+    	if (newProjectile != NULL && center_ != NULL)
+		{
+    		newProjectile->addTemplate(center_->getProjectileTemplate());
+    		newProjectile->setPosition(Vector3(xPosition, 0.0, zPosition));
+    		newProjectile->setVelocity(Vector3(xVelocity, 0.0, zVelocity));
+    		newProjectile->setFieldDimension(center_->getFieldDimension());
+    		newProjectile->setFigure(this->figure_);
+    		center_->attach(newProjectile);
+		}
+    }
+
+    void Jump::addEnemy1(float xPosition, float zPosition, float leftBoundary, float rightBoundary, float lowerBoundary, float upperBoundary, float xVelocity, float zVelocity)
+    {
+    	JumpEnemy* newEnemy = new JumpEnemy(center_->getContext());
+    	if (newEnemy != NULL && center_ != NULL)
+		{
+    		newEnemy->addTemplate(center_->getEnemy1Template());
+    		newEnemy->setPosition(Vector3(xPosition, 0.0, zPosition));
+    		newEnemy->setProperties(leftBoundary, rightBoundary, lowerBoundary, upperBoundary, xVelocity, zVelocity);
+    		newEnemy->setFieldDimension(center_->getFieldDimension());
+    		newEnemy->setFigure(this->figure_);
+    		center_->attach(newEnemy);
 		}
     }
@@ -409,8 +572,11 @@
 		JumpPlatform* newPlatform;
 
-		for (float xPosition = -center_->getFieldDimension().x; xPosition <= center_->getFieldDimension().x; xPosition += 12.0)
+		float sectionLength = center_->getSectionLength();
+		float platformLength = center_->getPlatformLength();
+
+		for (float xPosition = -center_->getFieldDimension().x; xPosition <= center_->getFieldDimension().x; xPosition += platformLength)
 		{
 			newPlatform = new JumpPlatformStatic(center_->getContext());
-			addPlatform(newPlatform, xPosition, -0.05*sectionLength);
+			addPlatform(newPlatform, center_->getPlatformStaticTemplate(), xPosition, -0.05*sectionLength);
 		}
     }
@@ -419,37 +585,146 @@
     {
         float fieldWidth = center_->getFieldDimension().x;
-        float fieldHeight = center_->getFieldDimension().y;
+        float sectionLength = center_->getSectionLength();
+        float platformLength = center_->getPlatformLength();
 
         float sectionBegin = sectionNumber * sectionLength;
         float sectionEnd = (1.0 + sectionNumber) * sectionLength;
 
-        JumpPlatformStatic* newPlatformStatic;
-        JumpPlatformHMove* newPlatformHMove;
-        JumpPlatformVMove* newPlatformVMove;
-
-		switch (rand()%3)
+		int randPos1 = rand()%10;
+		int randPos2 = rand()%10;
+		int randPos3 = rand()%10;
+		int randPos4 = rand()%10;
+
+		if (rand()%5 == 0)
+		{
+			addEnemy1(randomXPosition(), sectionBegin + sectionLength/10, -fieldWidth, fieldWidth, sectionBegin + sectionLength/10, sectionBegin + sectionLength/10, 5.0, 0.0);
+		}
+
+        switch (rand()%12)
 		{
 		case 0:
-			for (int i = 0; i < 10; ++i)
-			{
-				newPlatformStatic = new JumpPlatformStatic(center_->getContext());
-				addPlatform(newPlatformStatic, randomXPosition(), sectionBegin + i*sectionLength/10);
+			// Doppelt statisch
+			for (int i = 0; i < 10; ++i)
+			{
+				for (int j = 0; j < 2; ++j)
+				{
+					addPlatformStatic(randomXPosition(2, j), sectionBegin + i*sectionLength/10);
+				}
 			}
 			break;
 		case 1:
-			for (int i = 0; i < 10; ++i)
-			{
-				newPlatformHMove = new JumpPlatformHMove(center_->getContext());
-				newPlatformHMove->setProperties(-fieldWidth, fieldWidth, 30.0);
-				addPlatform(newPlatformHMove, randomXPosition(), sectionBegin + i*sectionLength/10);
-			}
-
+			// Dreifach statisch
+			for (int i = 0; i < 10; ++i)
+			{
+				for (int j = 0; j < 3; ++j)
+				{
+					addPlatformStatic(randomXPosition(3, j), sectionBegin + i*sectionLength/10);
+				}
+			}
 			break;
 		case 2:
-			for (int i = 0; i < 10; ++i)
-			{
-				newPlatformVMove = new JumpPlatformVMove(center_->getContext());
-				newPlatformVMove->setProperties(sectionBegin, sectionEnd, 20.0);
-				addPlatform(newPlatformVMove, -fieldWidth + i*fieldWidth*2/10, randomYPosition(sectionBegin, sectionEnd));
+			// statisch mit 1 horizontal
+			for (int i = 0; i < 10; ++i)
+			{
+				if (i == randPos1)
+				{
+					addPlatformHMove(randomXPosition(), sectionBegin + i*sectionLength/10, -fieldWidth, fieldWidth, 30.0);
+				}
+				else
+				{
+					addPlatformStatic(randomXPosition(), sectionBegin + i*sectionLength/10);
+				}
+			}
+			break;
+		case 3:
+			// statisch mit 2 horizontal
+			for (int i = 0; i < 10; ++i)
+			{
+				if (i == randPos1 || i == randPos2)
+				{
+					addPlatformHMove(randomXPosition(), sectionBegin + i*sectionLength/10, -fieldWidth, fieldWidth, 30.0);
+				}
+				else
+				{
+					addPlatformStatic(randomXPosition(), sectionBegin + i*sectionLength/10);
+				}
+			}
+			break;
+		case 4:
+			// statisch mit 3 horizontal
+			for (int i = 0; i < 10; ++i)
+			{
+				if (i == randPos1 || i == randPos2 || i == randPos3)
+				{
+					addPlatformHMove(randomXPosition(), sectionBegin + i*sectionLength/10, -fieldWidth, fieldWidth, 30.0);
+				}
+				else
+				{
+					addPlatformStatic(randomXPosition(), sectionBegin + i*sectionLength/10);
+				}
+			}
+			break;
+		case 5:
+			// statisch mit 4 horizontal
+			for (int i = 0; i < 10; ++i)
+			{
+				if (i == randPos1 || i == randPos2 || i == randPos3 || i == randPos4)
+				{
+					addPlatformHMove(randomXPosition(), sectionBegin + i*sectionLength/10, -fieldWidth, fieldWidth, 30.0);
+				}
+				else
+				{
+					addPlatformStatic(randomXPosition(), sectionBegin + i*sectionLength/10);
+				}
+			}
+			break;
+			// Einfach horizontal
+		case 6:
+			for (int i = 0; i < 10; ++i)
+			{
+				addPlatformHMove(randomXPosition(), sectionBegin + i*sectionLength/10, -fieldWidth, fieldWidth, 30.0);
+			}
+			break;
+			// Doppelt horizontal
+		case 7:
+			for (int i = 0; i < 10; ++i)
+			{
+					float mediumPos = randomXPosition(3, 1);
+					addPlatformHMove(randomXPosition(3, 0), sectionBegin + i*sectionLength/10, -fieldWidth, mediumPos - platformLength/2, 30.0);
+					addPlatformHMove(randomXPosition(3, 2), sectionBegin + i*sectionLength/10, mediumPos+platformLength/2, fieldWidth, 30.0);
+			}
+			break;
+			// Einfach vertikal
+		case 8:
+			for (int i = 0; i < 7; ++i)
+			{
+				addPlatformVMove(-fieldWidth + i*fieldWidth*2/10, randomYPosition(sectionBegin, sectionEnd), sectionBegin, sectionEnd, 20.0);
+			}
+			break;
+			// Doppelt vertikal
+		case 9:
+			for (int i = 0; i < 14; ++i)
+			{
+				addPlatformVMove(-fieldWidth + i*fieldWidth*2/10, randomYPosition(sectionBegin, sectionEnd), sectionBegin, sectionEnd, 20.0);
+			}
+			break;
+			// Doppelt verschwindend
+		case 10:
+			for (int i = 0; i < 10; ++i)
+			{
+				for (int j = 0; j < 2; ++j)
+				{
+					addPlatformDisappear(randomXPosition(2, j), randomYPosition(sectionBegin, sectionEnd));
+				}
+			}
+			break;
+			// Doppelt Timer
+		case 11:
+			for (int i = 0; i < 10; ++i)
+			{
+				for (int j = 0; j < 2; ++j)
+				{
+					addPlatformTimer(randomXPosition(2, j), randomYPosition(sectionBegin, sectionEnd), 6.0, 1.5);
+				}
 			}
 			break;
@@ -457,4 +732,6 @@
 		orxout() << "new section added with number "<< sectionNumber << endl;
 
+		fakeAdded_ = false;
+
 		++ sectionNumber;
     }
@@ -462,10 +739,23 @@
     float Jump::randomXPosition()
     {
-    	return (float)(rand()%(2*(int)center_->getFieldDimension().x)) - center_->getFieldDimension().x;
+        float fieldWidth = center_->getFieldDimension().x;
+
+    	return (float)(rand()%(2*(int)fieldWidth)) - fieldWidth;
+    }
+
+    float Jump::randomXPosition(int totalColumns, int culomn)
+    {
+    	float fieldWidth = center_->getFieldDimension().x;
+
+    	float width = 2*fieldWidth/totalColumns;
+    	float leftBound = culomn*width-fieldWidth;
+    	float platformLength = center_->getPlatformLength();
+
+    	return (float)(rand()%(int)(width-platformLength)) + leftBound + platformLength/2;
     }
 
     float Jump::randomYPosition(float lowerBoundary, float upperBoundary)
     {
-    	return (float)(rand()%(int)(upperBoundary - lowerBoundary)) + lowerBoundary;
+    	return (float)(rand()%(int)(100*(upperBoundary - lowerBoundary)))/100 + lowerBoundary;
     }
 
Index: code/branches/pickupsFS14/src/modules/jump/Jump.h
===================================================================
--- code/branches/pickupsFS14/src/modules/jump/Jump.h	(revision 10041)
+++ code/branches/pickupsFS14/src/modules/jump/Jump.h	(revision 10050)
@@ -80,10 +80,4 @@
             virtual void playerScored(PlayerInfo* player, int score = 1); //!< Is called when the player scored.
 
-            virtual void addPlatform(JumpPlatform* newPlatform, float xPosition, float zPosition);
-            virtual void addStartSection();
-            virtual void addSection();
-            virtual float randomXPosition();
-            virtual float randomYPosition(float lowerBoundary, float upperBoundary);
-
             int getScore(PlayerInfo* player) const;
 
@@ -104,6 +98,23 @@
             void cleanup(); //!< Cleans up the Gametype by destroying the ball and the bats.
 
+            virtual void addPlatform(JumpPlatform* newPlatform, std::string platformTemplate, float xPosition, float zPosition);
+
+            virtual void addPlatformStatic(float xPosition, float zPosition);
+            virtual void addPlatformHMove(float xPosition, float zPosition, float leftBoundary, float rightBoundary, float speed);
+            virtual void addPlatformVMove(float xPosition, float zPosition, float lowerBoundary, float upperBoundary, float speed);
+            virtual void addPlatformDisappear(float xPosition, float zPosition);
+            virtual void addPlatformTimer(float xPosition, float zPosition, float time, float variance);
+            virtual void addPlatformFake(float xPosition, float zPosition);
+            virtual void addProjectile(float xPosition, float zPosition, float xVelocity, float zVelocity);
+            virtual void addEnemy1(float xPosition, float zPosition, float leftBoundary, float rightBoundary, float lowerBoundary, float upperBoundary, float xVelocity, float zVelocity);
+
+            virtual void addStartSection();
+            virtual void addSection();
+
+            virtual float randomXPosition();
+            virtual float randomXPosition(int totalColumns, int culomn);
+            virtual float randomYPosition(float lowerBoundary, float upperBoundary);
+
             WeakPtr<JumpCenterpoint> center_; //!< The playing field.
-            //WeakPtr<JumpPlatform> ball_; //!< The Jump ball.
             WeakPtr<JumpFigure> figure_; //!< The two bats.
             WeakPtr<Camera> camera;
@@ -113,7 +124,7 @@
             float totalScreenShift;
             float screenShiftSinceLastUpdate;
-            float sectionLength;
             int sectionNumber;
-            std::list<JumpPlatform*> platformList;
+
+            bool fakeAdded_;
     };
 }
Index: code/branches/pickupsFS14/src/modules/jump/JumpCenterpoint.cc
===================================================================
--- code/branches/pickupsFS14/src/modules/jump/JumpCenterpoint.cc	(revision 10050)
+++ code/branches/pickupsFS14/src/modules/jump/JumpCenterpoint.cc	(revision 10050)
@@ -0,0 +1,107 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabian 'x3n' Landau
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+/**
+    @file JumpCenterpoint.cc
+    @brief Implementation of the JumpCenterpoint class.
+*/
+
+#include "JumpCenterpoint.h"
+
+#include "core/CoreIncludes.h"
+#include "core/XMLPort.h"
+
+#include "Jump.h"
+
+namespace orxonox
+{
+    RegisterClass(JumpCenterpoint);
+
+    /**
+    @brief
+        Constructor. Registers and initializes the object and checks whether the gametype is actually Jump.
+    */
+    JumpCenterpoint::JumpCenterpoint(Context* context) : StaticEntity(context)
+    {
+        RegisterObject(JumpCenterpoint);
+
+        // Variablen hier veraendern nuetzt nichts! Diese Variablen koennen in Level-File initialisiert werden.
+        width_ = 200;
+        height_ = 120;
+        sectionLength_ = 120;
+
+        this->checkGametype();
+    }
+
+    /**
+    @brief
+        Method to create a JumpCenterpoint through XML.
+    */
+    void JumpCenterpoint::XMLPort(Element& xmlelement, XMLPort::Mode mode)
+    {
+        SUPER(JumpCenterpoint, XMLPort, xmlelement, mode);
+
+        XMLPortParam(JumpCenterpoint, "dimension", setFieldDimension, getFieldDimension, xmlelement, mode);
+        XMLPortParam(JumpCenterpoint, "sectionLength", setSectionLength, getSectionLength, xmlelement, mode);
+        XMLPortParam(JumpCenterpoint, "platformLength", setPlatformLength, getPlatformLength, xmlelement, mode);
+        XMLPortParam(JumpCenterpoint, "platformStaticTemplate", setPlatformStaticTemplate, getPlatformStaticTemplate, xmlelement, mode);
+        XMLPortParam(JumpCenterpoint, "platformHMoveTemplate", setPlatformHMoveTemplate, getPlatformHMoveTemplate, xmlelement, mode);
+        XMLPortParam(JumpCenterpoint, "platformVMoveTemplate", setPlatformVMoveTemplate, getPlatformVMoveTemplate, xmlelement, mode);
+        XMLPortParam(JumpCenterpoint, "platformDisappearTemplate", setPlatformDisappearTemplate, getPlatformDisappearTemplate, xmlelement, mode);
+        XMLPortParam(JumpCenterpoint, "platformTimerTemplate", setPlatformTimerTemplate, getPlatformTimerTemplate, xmlelement, mode);
+        XMLPortParam(JumpCenterpoint, "platformFakeTemplate", setPlatformFakeTemplate, getPlatformFakeTemplate, xmlelement, mode);
+        XMLPortParam(JumpCenterpoint, "figureTemplate", setFigureTemplate, getFigureTemplate, xmlelement, mode);
+        XMLPortParam(JumpCenterpoint, "projectileTemplate", setProjectileTemplate, getProjectileTemplate, xmlelement, mode);
+        XMLPortParam(JumpCenterpoint, "enemy1Template", setEnemy1Template, getEnemy1Template, xmlelement, mode);
+    }
+
+    /**
+    @brief
+        Is called when the gametype has changed.
+    */
+    void JumpCenterpoint::changedGametype()
+    {
+        SUPER(JumpCenterpoint, changedGametype);
+
+        // Check, whether it's still Jump.
+        this->checkGametype();
+    }
+
+    /**
+    @brief
+        Checks whether the gametype is Jump and if it is, sets its centerpoint.
+    */
+    void JumpCenterpoint::checkGametype()
+    {
+        if (this->getGametype() != NULL && this->getGametype()->isA(Class(Jump)))
+        {
+            Jump* jumpGametype = orxonox_cast<Jump*>(this->getGametype().get());
+            jumpGametype->setCenterpoint(this);
+        }
+    }
+}
